#ifndef __GAME_H__
#define __GAME_H__
#include <memory>
#include <vector>
#include "constants.h"
#include "rng.h"
#include "spell.h" // this is for ncurses
#include "characters.h"
#include "map.h"

class game final {
private:
        feature features;
        std::unique_ptr<RNG> rng;
        std::unique_ptr<spell> spell;
        std::unique_ptr<character> player;
        std::vector<game_map> levels;
public:
        game(int argc = 0, char **argv = nullptr);
        void run();
};

#endif
